## tigervnc 1.14.1+dfsg

=== java/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10.0)

project(tigervnc-java Java)
if(NOT VERSION)
  set(VERSION 1.14.1)
endif()

find_package(Java)

set(DEFAULT_JAVACFLAGS "-source 8 -target 8 -encoding UTF-8 -Xlint:all,-serial,-cast,-unchecked,-fallthrough,-dep-ann,-deprecation,-rawtypes")
set(JAVACFLAGS ${DEFAULT_JAVACFLAGS} CACHE STRING
  "Java compiler flags (Default: ${DEFAULT_JAVACFLAGS})")
message(STATUS "Java compiler flags = ${JAVACFLAGS}")

set(CLASSPATH com/tigervnc/vncviewer)
set(SRCDIR ${CMAKE_CURRENT_SOURCE_DIR})
set(BINDIR ${CMAKE_CURRENT_BINARY_DIR})
set(JAVA_KEYSTORE NOTFOUND CACHE STRING "URL of keystore location")
set(JAVA_KEYSTORE_TYPE "jks" CACHE STRING "Type of keystore (Default: \"jks\")")
set(JAVA_KEY_ALIAS NOTFOUND CACHE STRING "Alias for the keystore entry used to generate the signature")
set(JAVA_STOREPASS NOTFOUND CACHE STRING "Password required to access the keystore")
set(JAVA_KEYPASS NOTFOUND CACHE STRING "Password used to protect the private key of the specified keystore entry")
set(JAVA_PKCS11_PROVIDER_CLASS "sun.security.pkcs11.SunPKCS11" CACHE STRING "PKCS11 SecurityProvider class name")
set(JAVA_PKCS11_PROVIDER_ARG NOTFOUND CACHE STRING "Path to the PKCS11 security provider class config file")
set(JAVA_TSA_URL NOTFOUND CACHE STRING "URL of Time Stamping Authority (TSA)")
set(JAVA_CERT_CHAIN NOTFOUND CACHE STRING "Path to CA certificate chain file")

if(NOT BUILD)
	STRING(TIMESTAMP BUILD "%Y%m%d" UTC)
endif()
STRING(TIMESTAMP JAVA_DATE "%Y-%m-%d" UTC)
STRING(TIMESTAMP JAVA_TIME "%H:%M:%S" UTC)

set(JAVA_SOURCES "")
set(JAVA_CLASSES "")

set(JSCH_CLASSNAMES
  DH
  DHEC256
  DHEC384
  DHEC521
  DHECN
  DHGEX256
  DHG1
  DHG14
  DHGEX
  ECDH
  JSch
  Session
  UserAuth
  UserAuthKeyboardInteractive
  UserAuthPassword
  UserAuthPublicKey
  UserAuthNone
  jce/AES128CBC
  jce/AES128CTR
  jce/AES192CBC
  jce/AES192CTR
  jce/AES256CBC
  jce/AES256CTR
  jce/ARCFOUR
  jce/ARCFOUR128
  jce/ARCFOUR256
  jce/BlowfishCBC
  jce/DH
	jce/ECDH256
	jce/ECDH384
	jce/ECDH521
	jce/ECDHN
  jce/HMAC
  jce/HMACMD5
  jce/HMACMD596
  jce/HMACSHA1
  jce/HMACSHA196
  jce/HMACSHA256
  jce/HMACSHA512
  jce/KeyPairGenDSA
  jce/KeyPairGenECDSA
  jce/KeyPairGenRSA
  jce/MD5
  jce/PBKDF
  jce/Random
  jce/SHA1
  jce/SHA256
  jce/SHA384
  jce/SHA512
  jce/SignatureDSA
  jce/SignatureECDSA
  jce/SignatureRSA
  jce/TripleDESCBC
  jce/TripleDESCTR
  jcraft/Compression
  jcraft/HMAC
  jcraft/HMACMD596
  jcraft/HMACMD5
  jcraft/HMACSHA196
  jcraft/HMACSHA1)

foreach(class ${JSCH_CLASSNAMES})
  set(JAVA_SOURCES ${JAVA_SOURCES} com/jcraft/jsch/${class}.java)
  set(JAVA_CLASSES ${JAVA_CLASSES}
    ${BINDIR}/com/jcraft/jsch/${class}.class)
endforeach()

file(GLOB DEPEND_SOURCES
  ${SRCDIR}/${CLASSPATH}/*.java
  ${SRCDIR}/com/tigervnc/rfb/*.java
  ${SRCDIR}/com/tigervnc/rdr/*.java
  ${SRCDIR}/com/tigervnc/network/*.java
  ${SRCDIR}/com/jcraft/jsch/*.java
  ${SRCDIR}/com/jcraft/jsch/jcraft/*.java
  ${SRCDIR}/com/jcraft/jsch/jgss/*.java
  ${SRCDIR}/com/jcraft/jzlib/*.java)

string(REGEX REPLACE " " ";" JAVACFLAGS "${JAVACFLAGS}")
add_custom_command(OUTPUT ${JAVA_CLASSES}
  DEPENDS ${JAVA_SOURCES} ${DEPEND_SOURCES}
  COMMAND ${JAVA_COMPILE}
  ARGS ${JAVACFLAGS} -sourcepath ${SRCDIR} -d ${BINDIR} 
    ${CLASSPATH}/VncViewer.java ${JAVA_SOURCES}
	WORKING_DIRECTORY ${SRCDIR})

configure_file(${CLASSPATH}/timestamp.in ${CLASSPATH}/timestamp)

if(NOT "${SRCDIR}" STREQUAL "${BINDIR}")

set(ICONS
tigervnc.ico
tigervnc.png
insecure.png
secure.png)

foreach(icon ${ICONS})
  add_custom_command(OUTPUT ${BINDIR}/${CLASSPATH}/${icon}
    COMMAND ${CMAKE_COMMAND} -E copy_if_different
      ${SRCDIR}/${CLASSPATH}/${icon} ${BINDIR}/${CLASSPATH}/${icon}
    DEPENDS ${SRCDIR}/${CLASSPATH}/${icon})
endforeach()

endif()

string(REGEX REPLACE "jar" "" Java_PATH ${Java_JAR_EXECUTABLE})
string(REGEX REPLACE ".exe" "" Java_PATH ${Java_PATH})

add_custom_command(OUTPUT VncViewer.jar
  DEPENDS ${JAVA_CLASSES}
    ${SRCDIR}/${CLASSPATH}/MANIFEST.MF
    ${BINDIR}/${CLASSPATH}/timestamp
    ${BINDIR}/${CLASSPATH}/tigervnc.ico
    ${BINDIR}/${CLASSPATH}/tigervnc.png
    ${BINDIR}/${CLASSPATH}/insecure.png
    ${BINDIR}/${CLASSPATH}/secure.png
  COMMAND ${JAVA_ARCHIVE}
  ARGS cfm VncViewer.jar
    ${SRCDIR}/${CLASSPATH}/MANIFEST.MF
    ${CLASSPATH}/timestamp
    ${CLASSPATH}/*.class
    com/tigervnc/rfb/*.class
    com/tigervnc/rdr/*.class
    com/tigervnc/network/*.class
    com/jcraft/jzlib/*.class
    com/jcraft/jsch/jcraft/*.class
    com/jcraft/jsch/jce/*.class
    com/jcraft/jsch/*.class
    com/tigervnc/vncviewer/*.png
    com/tigervnc/vncviewer/tigervnc.ico
  COMMAND ${CMAKE_COMMAND}
  ARGS -DJava_PATH=${Java_PATH} -DJAR_FILE=${BINDIR}/VncViewer.jar
    -DJAVA_KEYSTORE=${JAVA_KEYSTORE}
    -DJAVA_KEYSTORE_TYPE=${JAVA_KEYSTORE_TYPE}
    -DJAVA_STOREPASS=${JAVA_STOREPASS}
    -DJAVA_PKCS11_PROVIDER_CLASS=${JAVA_PKCS11_PROVIDER_CLASS}
    -DJAVA_PKCS11_PROVIDER_ARG=${JAVA_PKCS11_PROVIDER_ARG}
    -DJAVA_KEYPASS=${JAVA_KEYPASS}
    -DJAVA_KEY_ALIAS=${JAVA_KEY_ALIAS}
    -DJAVA_TSA_URL=${JAVA_TSA_URL}
    -DJAVA_CERT_CHAIN=${JAVA_CERT_CHAIN}
    -P ${SRCDIR}/cmake/SignJar.cmake)

add_custom_target(java ALL DEPENDS VncViewer.jar)

=== po/CMakeLists.txt ===
# Gettext support - mostly borrowed from the Licq project

file(STRINGS LINGUAS po_FILES)
set_property(DIRECTORY APPEND PROPERTY CMAKE_CONFIGURE_DEPENDS LINGUAS)

if (NOT GETTEXT_MSGMERGE_EXECUTABLE AND NOT GETTEXT_MSGFMT_EXECUTABLE)
  message(FATAL_ERROR "Gettext message catalog tools NOT found")
endif (NOT GETTEXT_MSGMERGE_EXECUTABLE AND NOT GETTEXT_MSGFMT_EXECUTABLE)

find_program(GETTEXT_XGETTEXT_EXECUTABLE xgettext)
if (GETTEXT_XGETTEXT_EXECUTABLE)
  # Get list of all source files
  file(GLOB_RECURSE po_source
    RELATIVE ${PROJECT_SOURCE_DIR}
    ${PROJECT_SOURCE_DIR}/vncviewer/*.h
    ${PROJECT_SOURCE_DIR}/vncviewer/*.cxx
    ${PROJECT_SOURCE_DIR}/vncviewer/*.desktop.in.in
    ${PROJECT_SOURCE_DIR}/vncviewer/*.metainfo.xml.in
  )

  add_custom_target(translations_update
    ${GETTEXT_XGETTEXT_EXECUTABLE}
      "--directory=${PROJECT_SOURCE_DIR}"
      "--output=${CMAKE_CURRENT_SOURCE_DIR}/tigervnc.pot"
      --default-domain=tigervnc
      --keyword=_
      --keyword=p_:1c,2
      --keyword=N_
      "--copyright-holder=TigerVNC Team and many others \(see README.rst\)"
      --msgid-bugs-address=tigervnc-devel@googlegroups.com
      --sort-by-file
      --add-location
      --add-comments=TRANSLATORS
      ${po_source}
    COMMENT "Updating tigervnc.pot"
    VERBATIM
  )
endif (GETTEXT_XGETTEXT_EXECUTABLE)

foreach(lang ${po_FILES})
  set(po  "${CMAKE_CURRENT_SOURCE_DIR}/${lang}.po")
  set(mo "${CMAKE_CURRENT_BINARY_DIR}/${lang}.mo")

  # Add command to build X.mo from X.po
  add_custom_command(OUTPUT ${mo}
    COMMAND ${GETTEXT_MSGFMT_EXECUTABLE} --check --check-accelerators -o ${mo} ${po}
    DEPENDS ${po}
  )

  install(FILES ${mo}
    DESTINATION "${CMAKE_INSTALL_FULL_LOCALEDIR}/${lang}/LC_MESSAGES"
    RENAME tigervnc.mo
  )

  set(moFiles ${moFiles} ${mo})
endforeach(lang)

add_custom_target(translations ALL DEPENDS ${moFiles})

=== release/CMakeLists.txt ===
# This file is included from the top-level CMakeLists.txt.  We just store it
# here to avoid cluttering up that file.


#
# Windows installer (Inno Setup)
#

if(WIN32)

if(CMAKE_SIZEOF_VOID_P MATCHES 8)
  set(INST_SUFFIX 64)
  set(INST_DEFS -DWIN64)
endif()

configure_file(tigervnc.iss.in tigervnc.iss)

add_custom_target(installer
  iscc -o. ${INST_DEFS} -F${CMAKE_PROJECT_NAME}${INST_SUFFIX}-${VERSION} tigervnc.iss
  DEPENDS vncviewer
  SOURCES tigervnc.iss)

if(BUILD_WINVNC)
  configure_file(winvnc.iss.in winvnc.iss)

  add_custom_target(winvnc_installer
    iscc -o. ${INST_DEFS} -F${CMAKE_PROJECT_NAME}${INST_SUFFIX}-winvnc-${VERSION} winvnc.iss
    DEPENDS winvnc4 wm_hooks vncconfig
    SOURCES winvnc.iss)
endif()

endif() # WIN32


#
# Mac DMG
#

if(APPLE)

configure_file(makemacapp.in makemacapp)
configure_file(Info.plist.in Info.plist)

add_custom_target(dmg sh makemacapp
  DEPENDS vncviewer
  SOURCES makemacapp)

endif() # APPLE


#
# Binary tarball
#

if(UNIX)

configure_file(maketarball.in maketarball)

set(TARBALL_DEPENDS vncviewer vncpasswd vncconfig)
if(BUILD_JAVA)
  set(TARBALL_DEPENDS ${TARBALL_DEPENDS} java)
endif()

add_custom_target(tarball bash maketarball
  DEPENDS ${TARBALL_DEPENDS})

add_custom_target(servertarball bash maketarball server
  DEPENDS ${TARBALL_DEPENDS})

endif() #UNIX

#
# Common
#

install(FILES ${CMAKE_SOURCE_DIR}/LICENCE.TXT DESTINATION ${CMAKE_INSTALL_FULL_DOCDIR})
install(FILES ${CMAKE_SOURCE_DIR}/README.rst DESTINATION ${CMAKE_INSTALL_FULL_DOCDIR})

=== unix/CMakeLists.txt ===
if(CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)
  message(FATAL_ERROR "cmake must be invoked with the top level directory")
endif()

add_subdirectory(tx)
add_subdirectory(common)
add_subdirectory(vncconfig)
add_subdirectory(vncpasswd)
add_subdirectory(vncserver)
add_subdirectory(x0vncserver)

=== vncviewer/CMakeLists.txt ===
if(CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)
  message(FATAL_ERROR "cmake must be invoked with the top level directory")
endif()

add_executable(vncviewer
  fltk/Fl_Monitor_Arrangement.cxx
  fltk/Fl_Navigation.cxx
  fltk/theme.cxx
  menukey.cxx
  BaseTouchHandler.cxx
  CConn.cxx
  DesktopWindow.cxx
  EmulateMB.cxx
  UserDialog.cxx
  ServerDialog.cxx
  Surface.cxx
  OptionsDialog.cxx
  PlatformPixelBuffer.cxx
  Viewport.cxx
  parameters.cxx
  keysym2ucs.c
  touch.cxx
  MonitorIndicesParameter.cxx
  vncviewer.cxx)

if(WIN32 AND NOT CMAKE_BUILD_TYPE STREQUAL "Debug")
  set_target_properties(vncviewer PROPERTIES WIN32_EXECUTABLE TRUE)
endif()

if(WIN32)
  # Since vncviewer.rc is generated, local includes will be looking
  # in the wrong directory. We need to help it out.
  target_include_directories(vncviewer PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})
  configure_file(vncviewer.rc.in vncviewer.rc)
  target_sources(vncviewer PRIVATE ${CMAKE_CURRENT_BINARY_DIR}/vncviewer.rc)
endif()

if(WIN32)
  target_sources(vncviewer PRIVATE Win32TouchHandler.cxx win32.c)
elseif(APPLE)
  target_sources(vncviewer PRIVATE cocoa.mm osx_to_qnum.c)
else()
  target_sources(vncviewer PRIVATE GestureHandler.cxx XInputTouchHandler.cxx xkb_to_qnum.c)
endif()

if(WIN32)
  target_sources(vncviewer PRIVATE Surface_Win32.cxx)
elseif(APPLE)
  target_sources(vncviewer PRIVATE Surface_OSX.cxx)
else()
  target_sources(vncviewer PRIVATE Surface_X11.cxx)
endif()

target_include_directories(vncviewer SYSTEM PUBLIC ${FLTK_INCLUDE_DIR})
target_include_directories(vncviewer SYSTEM PUBLIC ${GETTEXT_INCLUDE_DIR})
target_include_directories(vncviewer PUBLIC ${CMAKE_SOURCE_DIR}/common)
target_link_libraries(vncviewer rfb network rdr os ${FLTK_LIBRARIES} ${GETTEXT_LIBRARIES})

if(WIN32)
  target_link_libraries(vncviewer msimg32)
elseif(APPLE)
  target_link_libraries(vncviewer "-framework Cocoa")
  target_link_libraries(vncviewer "-framework Carbon")
  target_link_libraries(vncviewer "-framework IOKit")
else()
  target_link_libraries(vncviewer ${X11_Xi_LIB})

  if(X11_Xrandr_LIB)
    target_link_libraries(vncviewer ${X11_Xrandr_LIB})
  endif()
endif()

install(TARGETS vncviewer DESTINATION ${CMAKE_INSTALL_FULL_BINDIR})
if(UNIX)
  install(FILES vncviewer.man DESTINATION ${CMAKE_INSTALL_FULL_MANDIR}/man1 RENAME vncviewer.1)

  file(STRINGS ${CMAKE_SOURCE_DIR}/po/LINGUAS LINGUAS)
  set(po_FILES "")
  foreach(lang ${LINGUAS})
    list(APPEND po_FILES "${CMAKE_SOURCE_DIR}/po/${lang}.po")
  endforeach()

  configure_file(vncviewer.desktop.in.in vncviewer.desktop.in)
  find_program(INTLTOOL_MERGE_EXECUTABLE intltool-merge)
  if("${GETTEXT_VERSION_STRING}" VERSION_GREATER 0.18.99)
    add_custom_command(OUTPUT vncviewer.desktop
      COMMAND ${GETTEXT_MSGFMT_EXECUTABLE}
                --desktop --template vncviewer.desktop.in
                -d ${CMAKE_SOURCE_DIR}/po -o vncviewer.desktop
      DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/vncviewer.desktop.in
              ${po_FILES}
    )
  elseif(INTLTOOL_MERGE_EXECUTABLE)
    add_custom_command(OUTPUT vncviewer.desktop
      COMMAND sed -e 's/^Name/_Name/'
                -e 's/^GenericName/_GenericName/'
                -e 's/^Comment/_Comment/'
                vncviewer.desktop.in > vncviewer.desktop.intl
      COMMAND ${INTLTOOL_MERGE_EXECUTABLE}
                -d ${CMAKE_SOURCE_DIR}/po
                vncviewer.desktop.intl vncviewer.desktop
      DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/vncviewer.desktop.in
              ${po_FILES}
    )
  else()
    add_custom_command(OUTPUT vncviewer.desktop
      COMMAND cp vncviewer.desktop.in vncviewer.desktop
      DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/vncviewer.desktop.in
    )
  endif()
  add_custom_target(desktop ALL DEPENDS vncviewer.desktop)
  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/vncviewer.desktop DESTINATION ${CMAKE_INSTALL_FULL_DATADIR}/applications)

  if("${GETTEXT_VERSION_STRING}" VERSION_GREATER 0.19.6)
    add_custom_command(OUTPUT org.tigervnc.vncviewer.metainfo.xml
      COMMAND ${GETTEXT_MSGFMT_EXECUTABLE}
                --xml --template ${CMAKE_CURRENT_SOURCE_DIR}/org.tigervnc.vncviewer.metainfo.xml.in
                -d ${CMAKE_SOURCE_DIR}/po -o org.tigervnc.vncviewer.metainfo.xml
      DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/org.tigervnc.vncviewer.metainfo.xml.in
              ${po_FILES}
    )
  elseif(INTLTOOL_MERGE_EXECUTABLE)
    add_custom_command(OUTPUT org.tigervnc.vncviewer.metainfo.xml
      COMMAND sed -e 's@<name>@<_name>@\;s@</name>@</_name>@'
                  -e 's@<summary>@<_summary>@\;s@</summary>@</_summary>@'
                  -e 's@<caption>@<_caption>@\;s@</caption>@</_caption>@'
                  -e 's@<p>@<_p>@g\;s@</p>@</_p>@g'
                ${CMAKE_CURRENT_SOURCE_DIR}/org.tigervnc.vncviewer.metainfo.xml.in > org.tigervnc.vncviewer.metainfo.xml.intl
      COMMAND ${INTLTOOL_MERGE_EXECUTABLE}
                -x ${CMAKE_SOURCE_DIR}/po
                org.tigervnc.vncviewer.metainfo.xml.intl org.tigervnc.vncviewer.metainfo.xml
      DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/org.tigervnc.vncviewer.metainfo.xml.in
              ${po_FILES}
    )
  else()
    add_custom_command(OUTPUT org.tigervnc.vncviewer.metainfo.xml
      COMMAND cp ${CMAKE_CURRENT_SOURCE_DIR}/org.tigervnc.vncviewer.metainfo.xml.in org.tigervnc.vncviewer.metainfo.xml
      DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/org.tigervnc.vncviewer.metainfo.xml.in
    )
  endif()
  add_custom_target(appstream ALL DEPENDS org.tigervnc.vncviewer.metainfo.xml)
  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/org.tigervnc.vncviewer.metainfo.xml DESTINATION ${CMAKE_INSTALL_FULL_DATADIR}/metainfo)

  foreach(res 16 22 24 32 48 64 128)
    install(FILES ../media/icons/tigervnc_${res}.png DESTINATION ${CMAKE_INSTALL_FULL_DATADIR}/icons/hicolor/${res}x${res}/apps RENAME tigervnc.png)
  endforeach()
  install(FILES ../media/icons/tigervnc.svg DESTINATION ${CMAKE_INSTALL_FULL_DATADIR}/icons/hicolor/scalable/apps)
endif()

=== tests/unit/CMakeLists.txt ===
include_directories(${CMAKE_SOURCE_DIR}/common)
include_directories(${CMAKE_SOURCE_DIR}/vncviewer)

add_executable(conv conv.cxx)
target_link_libraries(conv rfb)

add_executable(convertlf convertlf.cxx)
target_link_libraries(convertlf rfb)

add_executable(gesturehandler gesturehandler.cxx ../../vncviewer/GestureHandler.cxx)
target_link_libraries(gesturehandler rfb)

add_executable(hostport hostport.cxx)
target_link_libraries(hostport rfb)

add_executable(pixelformat pixelformat.cxx)
target_link_libraries(pixelformat rfb)

add_executable(unicode unicode.cxx)
target_link_libraries(unicode rfb)

add_executable(emulatemb emulatemb.cxx ../../vncviewer/EmulateMB.cxx)
target_include_directories(emulatemb SYSTEM PUBLIC ${GETTEXT_INCLUDE_DIR})
target_link_libraries(emulatemb rfb  ${GETTEXT_LIBRARIES})

=== debian/changelog ===
tigervnc (1.14.1+dfsg-1) unstable; urgency=medium

  [ Joachim Falk ]
  * Fresh upstream TigerVNC 1.14.1
    - Xtigervnc now supports hardware accelerated OpenGL and Vulkan on
      drivers that supports GBM (FOSS drivers and newer Nvidia drivers)
    - The viewers and servers now follow the XDG Base Directory
      Specification, like "~/.config", for storing files in the home
      directory. Existing users will continue using the legacy "~/.vnc"
      directory, but new users will get the XDG directories.
    - The native viewer now supports Apple's Diffie-Hellman and UltraVNC's
      MSLogonII authentication methods
    - The Java viewer now supports RealVNC's RSA-AES authentication method
    - The native viewer has received a mild refresh of the UI appearance
    - Reverse connections can now be forced to be view-only
    - The special "%u" marker can be specified for "PlainUsers" to
      dynamically indicate the user running the server
    - X0tigervnc now supports systemd socket activation
  * TigerVNC configuration migrated to the ~/.config/tigervnc directory.
    Thus, updated the wrapper scripts.
  * TigerVNC configuration migrated to the ~/.config/tigervnc directory.
    Thus, updated the Debian specific man pages.
  * Wrapper scripts touch files in /tmp/tigervnc.* directory hourly to
    keep them active in case of /tmp cleaner.
  * Wrapper scripts tigervncserver and x0tigervncserver support the -pidfile
    option, allowing to specify the PID file of the VNC server to be started.
    (closes: #1025457)

 -- Joachim Falk <joachim.falk@gmx.de>  Sun, 10 Nov 2024 18:57:25 +0100

=== debian/control ===
Source: tigervnc
Section: x11
Priority: optional
Maintainer: TigerVNC Packaging Team <pkg-tigervnc-devel@lists.alioth.debian.org>
Uploaders:
 Joachim Falk <joachim.falk@gmx.de>,
 Mike Gabriel <sunweaver@debian.org>,
 Yaroslav Halchenko <debian@onerussian.com>,
 Ola Lundqvist <opal@debian.org>,
 Antoni Villalonga <antoni@friki.cat>
# all the Build-Depends up to x11proto-xf86-dri-dev are for the normal Xorg
# server, and common dependencies for the DIX.
# x11proto-xf86dri-dev and libdrm-dev are for DRI support for the Xorg server.
# x11proto-print-dev and libfreetype6-dev are for Xprint
# everything on is for the DMX and Xnest servers.
Build-Depends:
 debhelper-compat (= 12),
 cmake (>= 2.8),
 gettext,
 zlib1g-dev,
 libjpeg-dev,
 libgnutls28-dev,
 libpam0g-dev,
 libxft-dev,
 libxcursor-dev,
 libxrandr-dev,
 libxdamage-dev,
 libxcvt-dev,
 libwrap0-dev,
 libfltk1.3-dev (>= 1.3.3),
# For H.264 RFB encoding support
 libavcodec-dev,
 libavutil-dev,
 libswscale-dev,
 xorg-server-source (>= 2:21.1.10),
 xserver-xorg-dev,
 appstream,
# this are dependencies from xorg-server-21.1.10 source deb
# debhelper-compat (= 12),
 po-debconf,
 quilt,
 pkg-config,
 bison,
 flex,
 xutils-dev (>= 1:7.6+4),
 xfonts-utils (>= 1:7.5+1),
 x11proto-dev (>= 2021.5),
 xtrans-dev (>= 1.3.5),
 libxau-dev (>= 1:1.0.5-2),
 libxcvt-dev,
 libxdmcp-dev (>= 1:0.99.1),
 libxfont-dev (>= 1:2.0.1),
 libxkbfile-dev (>= 1:0.99.1),
 libpixman-1-dev (>= 0.27.2),
 libpciaccess-dev (>= 0.12.901),
 libgcrypt-dev,
 nettle-dev,
 libudev-dev (>= 151-3) [linux-any],
 libselinux1-dev (>= 2.0.80) [linux-any],
 libaudit-dev [linux-any],
 libdrm-dev (>= 2.4.107-5~) [!hurd-any],
 libgl-dev (>= 1.3.2),
 mesa-common-dev,
 libunwind-dev [amd64 arm64 armel armhf hppa i386 ia64 mips64 mips64el mipsel powerpc powerpcspe ppc64 ppc64el sh4],
 libxmuu-dev (>= 1:0.99.1),
 libxext-dev (>= 1:0.99.1),
 libx11-dev (>= 2:1.6),
 libxrender-dev (>= 1:0.9.0),
 libxi-dev (>= 2:1.8),
 libxpm-dev (>= 1:3.5.3),
 libxaw7-dev (>= 1:0.99.1),
 libxt-dev (>= 1:0.99.1),
 libxmu-dev (>= 1:0.99.1),
 libxtst-dev (>= 1:0.99.1),
 libxres-dev (>= 1:0.99.1),
 libxfixes-dev (>= 1:3.0.0),
 libxv-dev,
 libxinerama-dev,
 libxshmfence-dev (>= 1.1) [!hurd-any],
# glamor
 libepoxy-dev [linux-any kfreebsd-any],
 libegl-dev (>= 1.3.2) [linux-any kfreebsd-any],
 libgbm-dev (>= 10.2) [linux-any kfreebsd-any],
## XCB bits for Xephyr
# libx11-xcb-dev,
# libxcb1-dev,
# libxcb-xkb-dev,
# libxcb-shape0-dev,
# libxcb-render0-dev,
# libxcb-render-util0-dev,
# libxcb-util0-dev,
# libxcb-image0-dev,
# libxcb-icccm4-dev,
# libxcb-shm0-dev,
# libxcb-keysyms1-dev,
# libxcb-randr0-dev,
# libxcb-xv0-dev,
# libxcb-glx0-dev,
# libxcb-xf86dri0-dev (>= 1.6),
# unit tests
 xkb-data,
 x11-xkb-utils,
# arc4random_buf(), getpeereid()
 libbsd-dev,
#logind
  libdbus-1-dev (>= 1.0) [linux-any],
# systemd-daemon
  libsystemd-dev [linux-any],
Standards-Version: 4.6.2
Vcs-Git: https://salsa.debian.org/debian-remote-team/tigervnc.git
Vcs-Browser: https://salsa.debian.org/debian-remote-team/tigervnc
Homepage: http://www.tigervnc.org

Package: tigervnc-common
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: Virtual network computing; Common software needed by servers
 VNC stands for Virtual Network Computing. It is, in essence, a remote display
 system that allows you to view a computing `desktop' environment not only on
 the machine where it is running but from anywhere on the Internet and from a
 wide variety of machine architectures. For this purpose, it implements a
 client/server model.
 .
 This package provides the common infrastructure for the
 tigervnc-scraping-server and the tigervnc-standalone-server packages and the
 vncconfig tool, which should run in the `desktop' environment served by the
 VNC server.

Package: tigervnc-tools
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Replaces:
 tigervnc-common (<< 1.12)
Breaks:
 tigervnc-common (<< 1.12)
Description: Virtual network computing; Tools for both clients and servers
 VNC stands for Virtual Network Computing. It is, in essence, a remote display
 system that allows you to view a computing `desktop' environment not only on
 the machine where it is running but from anywhere on the Internet and from a
 wide variety of machine architectures. For this purpose, it implements a
 client/server model.
 .
 This package provides the vncpasswd tool.

Package: tigervnc-scraping-server
Architecture: any
Depends:
 tigervnc-common (= ${binary:Version}),
 ${shlibs:Depends},
 ${misc:Depends},
 ${perl:Depends},
 libfile-readbackwards-perl (>= 1.05)
Recommends:
 tigervnc-tools (= ${binary:Version})
Suggests:
 openssl
Provides:
 vnc-server
Description: Virtual network computing server performing X screen scraping
 VNC stands for Virtual Network Computing. It is, in essence, a remote display
 system that allows you to view a computing `desktop' environment not only on
 the machine where it is running but from anywhere on the Internet and from a
 wide variety of machine architectures. For this purpose, it implements a
 client/server model.
 .
 This package provides a VNC server that perform screen scraping of an already
 running X server to provide its VNC desktop. The VNC desktop can be viewed
 by any VNC viewer even on other operating systems.
 .
 Note: If you only want to scrape your local X11 server, you should consider
 the tigervnc-xorg-extension package. This package provides the vnc extension
 for your local X11 server. The usage of this extension is more efficient
 than a scraping vnc server.

Package: tigervnc-standalone-server
Architecture: any
Depends:
 xkb-data,
 x11-xkb-utils,
 xauth,
 tigervnc-common (= ${binary:Version}),
 ${shlibs:Depends},
 ${misc:Depends},
 ${perl:Depends},
 libfile-readbackwards-perl (>= 1.05)
Recommends:
 tigervnc-tools (= ${binary:Version}),
 libgl1-mesa-dri (>= 7.1~rc1),
 xfonts-base,
 x11-xserver-utils
Suggests:
 xfonts-100dpi | xfonts-75dpi,
 xfonts-scalable,
 openssl
Provides:
 vnc-server,
 xserver
Description: Standalone virtual network computing server
 VNC stands for Virtual Network Computing. It is, in essence, a remote display
 system that allows you to view a computing `desktop' environment not only on
 the machine where it is running but from anywhere on the Internet and from a
 wide variety of machine architectures. For this purpose, it implements a
 client/server model.
 .
 This package provides a standalone VNC server to which clients can connect.
 The server generates a display that can be viewed with a vncviewer.
 .
 Note: This server does not need a display. You need a VNC viewer to see
 something. This viewer may also be on a computer running other operating
 systems.

Package: tigervnc-xorg-extension
Architecture: any
Depends:
 xserver-xorg-core (>= 2:1.7.7),
 ${shlibs:Depends},
 ${misc:Depends},
Recommends:
 tigervnc-tools (= ${binary:Version}),
 tigervnc-common (= ${binary:Version})
Provides:
 vnc-server,
 vnc-xorg-extension
Description: Virtual network computing X server extension
 VNC stands for Virtual Network Computing. It is, in essence, a remote display
 system that allows you to view a computing `desktop' environment not only on
 the machine where it is running but from anywhere on the Internet and from a
 wide variety of machine architectures. For this purpose, it implements a
 client/server model.
 .
 This package contains an X server connector so VNC clients can connect to your
 local X desktop directly.

Package: tigervnc-viewer
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Suggests:
 tigervnc-tools (= ${binary:Version})
Provides:
 vncviewer,
 vnc-viewer
Description: Virtual network computing client for X
 VNC stands for Virtual Network Computing. It is, in essence, a remote display
 system that allows you to view a computing `desktop' environment not only on
 the machine where it is running but from anywhere on the Internet and from a
 wide variety of machine architectures. For this purpose, it implements a
 client/server model.
 .
 This package provides a VNC client for X. With this you can connect to a
 VNC server and display its content. There are VNC servers available for other
 operating systems.

#Package: tigervnc-java
#Architecture: all
#Depends:
# openjdk-7-jre
#Provides:
# vnc-java-viewer
#Enhances:
# tigervnc-standalone-server
#Description: Virtual network computing java applet and command line program
# VNC stands for Virtual Network Computing. It is, in essence, a remote
# display system which allows you to view a computing `desktop' environment
# not only on the machine where it is running, but from anywhere on the
# Internet and from a wide variety of machine architectures.
# .
# It contains a java viewer implementation that can either be used as an applet,
# typically served by the built in web server provided by Xvnc
# (tigervnc-standalone-server) or from command line using a Java JRE.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1


# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

# Normal situation
#VNC_PATCH = $(CURDIR)/unix/xserver120.patch
# However in this case we do not have this file from upstream so we use a
# debian specific copy instead.
VNC_PATCH = $(CURDIR)/debian/xserver121.patch

VNC_LIBTOOL_PATCH = $(CURDIR)/contrib/packages/deb/ubuntu-jammy/debian/xorg-source-patches/debian_libtool.patch

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/buildflags.mk

# This is stolen from xorg-server/debian/xsfbs/xsfbs.mk
# Determine (source) package name from Debian changelog.
SOURCE_NAME:=$(shell dpkg-parsechangelog -SSource)

# Determine package version from Debian changelog.
SOURCE_VERSION:=$(shell dpkg-parsechangelog -SVersion)

# Determine package date from Debian changelog.
BUILD_TIMESTAMP:=$(shell dpkg-parsechangelog -SDate | date -u -f- '+%Y-%m-%d %H:%M')
export BUILD_TIMESTAMP

# Strip a possible epoch marker from source version.
NO_EPOCH_VER:=$(shell echo $(SOURCE_VERSION) | sed 's/^.://')

# Determine upstream version number for make get-orig-source
UPSTREAM_DFSG_VERSION:=$(shell echo $(NO_EPOCH_VER) | sed 's/-.*//')

# Determine upstream version number.
UPSTREAM_VERSION:=$(shell echo $(UPSTREAM_DFSG_VERSION) | cut -d"+" -f1)

DEB_DESTDIR := $(CURDIR)/debian/tmp

TIGERVNC_SRCDIR		:= $(CURDIR)
TIGERVNC_BUILDDIR	:= $(CURDIR)/obj-$(DEB_HOST_MULTIARCH)

XTIGERVNC_SRCDIR	:= $(CURDIR)/unix/xserver
XTIGERVNC_BUILDDIR	:= $(CURDIR)/obj-$(DEB_HOST_MULTIARCH)/unix/xserver

# Work around bug #641051 (See https://bugs.debian.org/641051)
DEB_CMAKE_EXTRA_FLAGS	:= -DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH)

#DEB_CMAKE_EXTRA_FLAGS	+= -DENABLE_LIBWRAP:BOOL=ON
DEB_CMAKE_EXTRA_FLAGS	+= -DENABLE_NLS:BOOL=ON
DEB_CMAKE_EXTRA_FLAGS	+= -DENABLE_NETTLE:BOOL=ON
DEB_CMAKE_EXTRA_FLAGS	+= -DENABLE_GNUTLS:BOOL=ON
DEB_CMAKE_EXTRA_FLAGS	+= -DENABLE_H264:BOOL=ON
#DEB_CMAKE_EXTRA_FLAGS	+= -DBUILD_JAVA=1
DEB_CMAKE_EXTRA_FLAGS   += -DBUILD_TIMESTAMP="$(BUILD_TIMESTAMP)"

# Unfortunately quoting in /usr/share/xserver-xorg/configure_flags.mk is fucked
# up in buster and ${xxx} is not escaped correctly.
xserver_confflags := $(shell cat /usr/share/xserver-xorg/configure_flags.mk | \
  sed -ne '/^xserver_confflags\s*=/{s/^[^=]*=//;s/--with-builderstring="[^"]*"//;p}')

#-include /usr/share/xserver-xorg/configure_flags.mk
#xserver_confflags := $(shell echo '$(xserver_confflags)' | sed 's/--with-builderstring="[^"]*"//')

XORG_DEBIAN_CONFIGURE_FLAGS := \
	$(filter-out \
		--prefix=% \
		--mandir=% \
		--infodir=% \
		--sysconfdir=% \
		--localstatedir=% \
		--build=% \
		--host=% \
		--enable-xwayland \
		--enable-dmx \
		--enable-xvfb \
		--enable-xnest \
		--enable-xephyr \
		--enable-xorg \
		--enable-dri \
		--enable-dri2 \
		--enable-dri3 \
		--enable-xmir \
	    , $(xserver_confflags) \
	)

DEB_CONFIGURE_EXTRA_FLAGS := \
	--disable-selective-werror \
	--with-builderstring="tigervnc-xorg-server $(NO_EPOCH_VER) (TigerVNC Packaging Team <pkg-tigervnc-devel@lists.alioth.debian.org>)" \
	--disable-xwayland \
	--disable-dmx \
	--disable-xvfb \
	--disable-xnest \
	--disable-xephyr \
	--disable-xorg \
	--disable-dri \
	--disable-dri2 \
	--disable-dri3

# Don't use libunwind for armel, armhf, and arm64 as this library is buggy
# (bug #923962) on those architectures.
ifneq (,$(filter $(DEB_HOST_ARCH), armel armhf arm64))
	DEB_CONFIGURE_EXTRA_FLAGS += --disable-libunwind
	XORG_DEBIAN_CONFIGURE_FLAGS := \
	    $(filter-out --enable-libunwind, $(XORG_DEBIAN_CONFIGURE_FLAGS))
endif
DEB_CONFIGURE_EXTRA_FLAGS += \
	CPPFLAGS='$(CPPFLAGS) -DBUILD_TIMESTAMP="\"$${BUILD_TIMESTAMP}\""'

.PHONY: debug-debian-rules
debug-debian-rules:
	@echo '$$(SOURCE_NAME) $(SOURCE_NAME)'
	@echo '$$(BUILD_TIMESTAMP) $(BUILD_TIMESTAMP)'
	@echo '$$(SOURCE_VERSION) $(SOURCE_VERSION)'
	@echo '$$(NO_EPOCH_VER) $(NO_EPOCH_VER)'
	@echo '$$(UPSTREAM_DFSG_VERSION) $(UPSTREAM_DFSG_VERSION)'
	@echo '$$(UPSTREAM_VERSION) $(UPSTREAM_VERSION)'
	@echo '$$(TIGERVNC_SRCDIR) $(TIGERVNC_SRCDIR)'
	@echo '$$(TIGERVNC_BUILDDIR) $(TIGERVNC_BUILDDIR)'
	@echo '$$(XTIGERVNC_SRCDIR) $(XTIGERVNC_SRCDIR)'
	@echo '$$(XTIGERVNC_BUILDDIR) $(XTIGERVNC_BUILDDIR)'
	@echo '$$(DEB_HOST_ARCH) $(DEB_HOST_ARCH)'
	@echo '$$(DEB_HOST_MULTIARCH) $(DEB_HOST_MULTIARCH)'
	@echo '$$(XORG_DEBIAN_CONFIGURE_FLAGS) $(XORG_DEBIAN_CONFIGURE_FLAGS)'
	@echo '$$(DEB_CMAKE_EXTRA_FLAGS) $(DEB_CMAKE_EXTRA_FLAGS)'
	@echo '$$(DEB_CONFIGURE_EXTRA_FLAGS) $(DEB_CONFIGURE_EXTRA_FLAGS)'
	@echo '$$(DEB_DESTDIR) $(DEB_DESTDIR)'

.PHONY: override_dh_autoreconf
override_dh_autoreconf:
	dh_autoreconf
	cd $(XTIGERVNC_SRCDIR) && { \
	    patch --no-backup-if-mismatch -p1 < $(VNC_LIBTOOL_PATCH); \
	  }

.PHONY: override_dh_auto_configure
override_dh_auto_configure:
	dh_auto_configure -D$(TIGERVNC_SRCDIR) -B$(TIGERVNC_BUILDDIR) -- \
		$(DEB_CMAKE_EXTRA_FLAGS)
	dh_auto_configure -D$(XTIGERVNC_SRCDIR) -B$(XTIGERVNC_BUILDDIR) -- \
		$(XORG_DEBIAN_CONFIGURE_FLAGS) \
		$(DEB_CONFIGURE_EXTRA_FLAGS)

.PHONY: override_dh_auto_build
override_dh_auto_build:
	dh_auto_build -D$(TIGERVNC_SRCDIR) -B$(TIGERVNC_BUILDDIR)
	dh_auto_build -D$(XTIGERVNC_SRCDIR) -B$(XTIGERVNC_BUILDDIR)

.PHONY: override_dh_auto_install
override_dh_auto_install:
	dh_auto_install -D$(TIGERVNC_SRCDIR) -B$(TIGERVNC_BUILDDIR)
	dh_auto_install -D$(XTIGERVNC_SRCDIR) -B$(XTIGERVNC_BUILDDIR)
	mv $(DEB_DESTDIR)/usr/share/doc/tigervnc \
	  $(DEB_DESTDIR)/usr/share/doc/tigervnc-common
	mv $(DEB_DESTDIR)/usr/bin/vncviewer \
	  $(DEB_DESTDIR)/usr/bin/xvncviewer
	mv $(DEB_DESTDIR)/usr/share/man/man1/vncviewer.1 \
	  $(DEB_DESTDIR)/usr/share/man/man1/xvncviewer.1
	mv $(DEB_DESTDIR)/usr/bin/x0vncserver \
	  $(DEB_DESTDIR)/usr/bin/X0vnc
	mv $(DEB_DESTDIR)/usr/share/man/man1/x0vncserver.1 \
	  $(DEB_DESTDIR)/usr/share/man/man1/X0vnc.1
	mv $(DEB_DESTDIR)/usr/share/applications/vncviewer.desktop \
	  $(DEB_DESTDIR)/usr/share/applications/xvncviewer.desktop
	mkdir -p $(DEB_DESTDIR)/usr/share/icons/hicolor/scalable/apps
	cp media/icons/tigervnc.svg \
	  $(DEB_DESTDIR)/usr/share/icons/hicolor/scalable/apps/
	for i in 16 22 24 32 48; do \
	  mkdir -p $(DEB_DESTDIR)/usr/share/icons/hicolor/$${i}x$${i}/apps; \
	  cp media/icons/tigervnc_$${i}.png \
	    $(DEB_DESTDIR)/usr/share/icons/hicolor/$${i}x$${i}/apps/tigervnc.png; \
	done
	# Hack, replace media/icons/tigervnc_16.png of wrong dimensions 20x20 by our fixed version.
	cp debian/tigervnc_16.png \
	  $(DEB_DESTDIR)/usr/share/icons/hicolor/16x16/apps/tigervnc.png
	cd $(DEB_DESTDIR) && \
	  find usr/bin usr/sbin usr/lib/systemd/system usr/libexec usr/share/man usr/share/applications -name "*vnc*" | \
	  while read line; do \
	    echo Rename "$$line" `echo "$$line" | sed -e 's/vnc/tigervnc/g'` ; \
	    mv "$$line" `echo "$$line" | sed -e 's/vnc/tigervnc/g'`; \
	  done
	# Fixup org.tigervnc.vncviewer.metainfo.xml
	sed -i \
	  -e 's/<release version="\([0-9.]\+\)"/<release version="\1+dfsg"/' \
	  -e 's/<launchable type="desktop-id">vncviewer.desktop<\/launchable>/<launchable type="desktop-id">xtigervncviewer.desktop<\/launchable>/' \
	  $(DEB_DESTDIR)/usr/share/metainfo/org.tigervnc.vncviewer.metainfo.xml
	cp -pr debian/helpers/* \
	  debian/tmp
	find debian/tmp/usr/share/man -type f | while read line; do \
	  echo "Rewriting and renaming $$line into $$line.gz" ; \
	  sed -e 's/\(\<\|\\f[IBP]\)vncviewer\>/\1xtigervncviewer/g' \
	      -e 's/\(\<\|\\f[IBP]\)vncpasswd\>/\1tigervncpasswd/g' \
	      -e 's/\(\<\|\\f[IBP]\)vncconfig\>/\1tigervncconfig/g' \
	      -e 's/\(\<\|\\f[IBP]\)vncserver\>/\1tigervncserver/g' \
	      -e 's/\(\<\|\\f[IBP]\)vncsession\>/\1tigervncsession/g' \

## tigervnc 1.15.0%2Bdfsg

=== unix/vncconfig/CMakeLists.txt ===
add_executable(vncconfig 
  buildtime.c
  vncExt.c
  vncconfig.cxx
  QueryConnectDialog.cxx)

target_include_directories(vncconfig SYSTEM PUBLIC ${X11_INCLUDE_DIR})

target_include_directories(vncconfig PUBLIC ${CMAKE_SOURCE_DIR}/common)
target_include_directories(vncconfig PUBLIC ${CMAKE_SOURCE_DIR}/unix/tx)

target_link_libraries(vncconfig tx rfb network rdr ${X11_LIBRARIES})

install(TARGETS vncconfig DESTINATION ${CMAKE_INSTALL_FULL_BINDIR})
install(FILES vncconfig.man DESTINATION ${CMAKE_INSTALL_FULL_MANDIR}/man1 RENAME vncconfig.1)

## tigervnc 1.15.0+dfsg

=== media/CMakeLists.txt ===
set(LINUX_ICON_SIZES 16 22 24 32 48 64 128)
set(WINDOWS_ICON_SIZES 16 24 32 48 256)
set(MACOS_ICON_SIZES 16 32 128 256 512)

find_program(CONVERT_EXECUTABLE convert)
find_program(PNG2ICNS_EXECUTABLE png2icns)

if(CONVERT_EXECUTABLE)
  set(ICON_FILES icons/tigervnc.ico)
  foreach(SIZE ${LINUX_ICON_SIZES})
    list(APPEND ICON_FILES ${CMAKE_CURRENT_SOURCE_DIR}/icons/tigervnc_${SIZE}.png)
  endforeach()
  if(PNG2ICNS_EXECUTABLE)
    list(APPEND ICON_FILES icons/tigervnc.icns)
  endif()
  add_custom_target(icons DEPENDS ${ICON_FILES})

  foreach(SIZE ${LINUX_ICON_SIZES} ${WINDOWS_ICON_SIZES} ${MACOS_ICON_SIZES})
    if(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/tigervnc_${SIZE}.svg)
      set(ICON_SRC_FILE ${CMAKE_CURRENT_SOURCE_DIR}/tigervnc_${SIZE}.svg)
    else()
      set(ICON_SRC_FILE ${CMAKE_CURRENT_SOURCE_DIR}/tigervnc_48.svg)
    endif()
    add_custom_command(OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/icons/tigervnc_${SIZE}.png
      COMMAND ${CONVERT_EXECUTABLE} -depth 8 -background transparent
        -size ${SIZE}x${SIZE} ${ICON_SRC_FILE}
        ${CMAKE_CURRENT_SOURCE_DIR}/icons/tigervnc_${SIZE}.png
      DEPENDS ${ICON_SRC_FILE}
      COMMENT "Generating icons/tigervnc_${SIZE}.png")
  endforeach()

  foreach(SIZE ${WINDOWS_ICON_SIZES})
    if(${SIZE} LESS_EQUAL 32)
      list(APPEND ICO_LEGACY \\\( ${CMAKE_CURRENT_SOURCE_DIR}/icons/tigervnc_${SIZE}.png -depth 4 -colors 16 \\\))
      list(APPEND ICO_LEGACY \\\( ${CMAKE_CURRENT_SOURCE_DIR}/icons/tigervnc_${SIZE}.png -depth 8 -colors 256 \\\))
    endif()
    list(APPEND ICO_NORMAL \\\( ${CMAKE_CURRENT_SOURCE_DIR}/icons/tigervnc_${SIZE}.png \\\))
    list(APPEND ICO_DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/icons/tigervnc_${SIZE}.png)
  endforeach()
  add_custom_command(OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/icons/tigervnc.ico
    COMMAND ${CONVERT_EXECUTABLE} ${ICO_LEGACY} ${ICO_NORMAL}
      ${CMAKE_CURRENT_SOURCE_DIR}/icons/tigervnc.ico
    DEPENDS ${ICO_DEPENDS}
    COMMENT "Generating icons/tigervnc.ico")

  if(PNG2ICNS_EXECUTABLE)
    # FIXME: Should be a drop shadow here as well
    foreach(SIZE ${MACOS_ICON_SIZES})
      list(APPEND ICNS_FILES ${CMAKE_CURRENT_SOURCE_DIR}/icons/tigervnc_${SIZE}.png)
    endforeach()
    add_custom_command(OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/icons/tigervnc.icns
      COMMAND ${PNG2ICNS_EXECUTABLE}
          ${CMAKE_CURRENT_SOURCE_DIR}/icons/tigervnc.icns ${ICNS_FILES}
      DEPENDS ${ICNS_FILES}
      COMMENT "Generating icons/tigervnc.icns")
  endif()
endif()

=== po/CMakeLists.txt ===
--- 
+++ 
@@ -26,7 +26,7 @@
       --keyword=_
       --keyword=p_:1c,2
       --keyword=N_
-      "--copyright-holder=TigerVNC Team and many others \(see README.rst\)"
+      "--copyright-holder=TigerVNC team and many others \(see README.rst\)"
       --msgid-bugs-address=tigervnc-devel@googlegroups.com
       --sort-by-file
       --add-location

=== tests/CMakeLists.txt ===
if(CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)
  message(FATAL_ERROR "cmake must be invoked with the top level directory")
endif()

# Benchmarking tools
add_subdirectory(perf)

# Unit tests
add_subdirectory(unit)

=== common/network/CMakeLists.txt ===
add_library(network STATIC
  Socket.cxx
  TcpSocket.cxx)

if(NOT WIN32)
  target_sources(network PRIVATE UnixSocket.cxx)
endif()

target_include_directories(network PUBLIC ${CMAKE_SOURCE_DIR}/common)
target_link_libraries(network os rdr rfb)

if(WIN32)
	target_link_libraries(network ws2_32)
endif()

if(UNIX)
  libtool_create_control_file(network)
endif()

=== common/os/CMakeLists.txt ===
add_library(os STATIC
  Mutex.cxx
  Thread.cxx
  os.cxx)

target_include_directories(os PUBLIC ${CMAKE_SOURCE_DIR}/common)
target_link_libraries(os rdr)

if(UNIX)
  target_link_libraries(os pthread)
endif()

if(UNIX)
  libtool_create_control_file(os)
endif()

=== common/rfb/CMakeLists.txt ===
add_library(rfb STATIC
  AccessRights.cxx
  Blacklist.cxx
  Congestion.cxx
  CConnection.cxx
  CMsgHandler.cxx
  CMsgReader.cxx
  CMsgWriter.cxx
  CSecurityPlain.cxx
  CSecurityStack.cxx
  CSecurityVeNCrypt.cxx
  CSecurityVncAuth.cxx
  ClientParams.cxx
  ComparingUpdateTracker.cxx
  Configuration.cxx
  CopyRectDecoder.cxx
  Cursor.cxx
  DecodeManager.cxx
  Decoder.cxx
  d3des.c
  EncodeManager.cxx
  Encoder.cxx
  HextileDecoder.cxx
  HextileEncoder.cxx
  JpegCompressor.cxx
  JpegDecompressor.cxx
  KeyRemapper.cxx
  KeysymStr.c
  LogWriter.cxx
  Logger.cxx
  Logger_file.cxx
  Logger_stdio.cxx
  PixelBuffer.cxx
  PixelFormat.cxx
  RREEncoder.cxx
  RREDecoder.cxx
  RawDecoder.cxx
  RawEncoder.cxx
  Region.cxx
  SConnection.cxx
  SMsgHandler.cxx
  SMsgReader.cxx
  SMsgWriter.cxx
  ServerCore.cxx
  ServerParams.cxx
  Security.cxx
  SecurityServer.cxx
  SecurityClient.cxx
  SSecurityPlain.cxx
  SSecurityStack.cxx
  SSecurityVncAuth.cxx
  SSecurityVeNCrypt.cxx
  Timer.cxx
  TightDecoder.cxx
  TightEncoder.cxx
  TightJPEGEncoder.cxx
  UpdateTracker.cxx
  VNCSConnectionST.cxx
  VNCServerST.cxx
  ZRLEEncoder.cxx
  ZRLEDecoder.cxx
  encodings.cxx
  obfuscate.cxx
  util.cxx)

target_include_directories(rfb PUBLIC ${CMAKE_SOURCE_DIR}/common)
target_include_directories(rfb SYSTEM PUBLIC ${JPEG_INCLUDE_DIR})
target_include_directories(rfb SYSTEM PUBLIC ${PIXMAN_INCLUDE_DIRS})
target_link_libraries(rfb os rdr network)
target_link_libraries(rfb ${JPEG_LIBRARIES} ${PIXMAN_LIBRARIES})
target_link_directories(rfb PUBLIC ${PIXMAN_LIBRARY_DIRS})

if(ENABLE_H264 AND NOT H264_LIBS STREQUAL "NONE")
  target_sources(rfb PRIVATE H264Decoder.cxx H264DecoderContext.cxx)
  if(H264_LIBS STREQUAL "LIBAV")
    target_sources(rfb PRIVATE H264LibavDecoderContext.cxx)
  elseif(H264_LIBS STREQUAL "WIN")
    target_sources(rfb PRIVATE H264WinDecoderContext.cxx)
  endif()
  target_include_directories(rfb SYSTEM PUBLIC ${H264_INCLUDE_DIRS})
  target_link_libraries(rfb ${H264_LIBRARIES})
  target_link_directories(rfb PUBLIC ${H264_LIBRARY_DIRS})
endif()

if(UNIX)
  target_sources(rfb PRIVATE Logger_syslog.cxx)
endif()

if(WIN32)
  target_include_directories(rfb PUBLIC ${CMAKE_SOURCE_DIR}/win)
  target_sources(rfb PRIVATE WinPasswdValidator.cxx)
endif(WIN32)

if(UNIX AND NOT APPLE)
  target_sources(rfb PRIVATE UnixPasswordValidator.cxx pam.c)
  target_link_libraries(rfb ${PAM_LIBS})
endif()

if(GNUTLS_FOUND)
  target_sources(rfb PRIVATE CSecurityTLS.cxx SSecurityTLS.cxx)
  target_include_directories(rfb SYSTEM PUBLIC ${GNUTLS_INCLUDE_DIR})
  target_link_libraries(rfb ${GNUTLS_LIBRARIES})
  # FIXME: Hack to block it marking gnutls_free() as dllimport
  if(WIN32 AND BUILD_STATIC)
    target_compile_definitions(rfb PRIVATE GNUTLS_INTERNAL_BUILD)
  endif()
endif()

if (NETTLE_FOUND)
  target_sources(rfb PRIVATE CSecurityDH.cxx CSecurityMSLogonII.cxx
                 CSecurityRSAAES.cxx SSecurityRSAAES.cxx)
  target_include_directories(rfb SYSTEM PUBLIC ${NETTLE_INCLUDE_DIRS}
                             ${GMP_INCLUDE_DIRS})
  target_link_libraries(rfb ${HOGWEED_LIBRARIES}
                        ${NETTLE_LIBRARIES} ${GMP_LIBRARIES})
  target_link_directories(rfb PUBLIC ${HOGWEED_LIBRARY_DIRS}
                          ${NETTLE_LIBRARY_DIRS} ${GMP_LIBRARY_DIRS})
endif()

if(UNIX)
  libtool_create_control_file(rfb)
endif()

=== tests/unit/CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,8 @@
 include_directories(${CMAKE_SOURCE_DIR}/common)
 include_directories(${CMAKE_SOURCE_DIR}/vncviewer)
+
+add_executable(configargs configargs.cxx)
+target_link_libraries(configargs rfb)
 
 add_executable(conv conv.cxx)
 target_link_libraries(conv rfb)

=== unix/common/CMakeLists.txt ===
add_library(unixcommon STATIC
  randr.cxx)

target_include_directories(unixcommon PUBLIC ${CMAKE_SOURCE_DIR}/common)
target_include_directories(unixcommon PUBLIC ${CMAKE_SOURCE_DIR}/unix/common)

if(UNIX)
  libtool_create_control_file(unixcommon)
endif()

if(NOT WIN32)
  set_target_properties(unixcommon
    PROPERTIES COMPILE_FLAGS -fPIC)
endif()

=== unix/tx/CMakeLists.txt ===
add_library(tx STATIC
  TXWindow.cxx)

target_include_directories(tx SYSTEM PUBLIC ${X11_INCLUDE_DIR})

target_include_directories(tx PUBLIC ${CMAKE_SOURCE_DIR}/common)
target_include_directories(tx PUBLIC ${CMAKE_SOURCE_DIR}/common/rfb)

target_link_libraries(tx ${X11_LIBRARIES})

=== unix/x0vncserver/CMakeLists.txt ===
add_executable(x0vncserver
  buildtime.c
  Geometry.cxx
  Image.cxx
  PollingManager.cxx
  PollingScheduler.cxx
  TimeMillis.cxx
  qnum_to_xorgevdev.c
  qnum_to_xorgkbd.c
  x0vncserver.cxx
  XPixelBuffer.cxx
  XDesktop.cxx
  RandrGlue.c
  XSelection.cxx
  ../vncconfig/QueryConnectDialog.cxx
)

target_include_directories(x0vncserver SYSTEM PUBLIC ${X11_INCLUDE_DIR})
target_include_directories(x0vncserver PUBLIC ${CMAKE_SOURCE_DIR}/unix/common)
target_include_directories(x0vncserver PUBLIC ${CMAKE_SOURCE_DIR}/unix/tx)
target_include_directories(x0vncserver PUBLIC ${CMAKE_SOURCE_DIR}/unix)
target_include_directories(x0vncserver PUBLIC ${CMAKE_SOURCE_DIR}/common)
target_link_libraries(x0vncserver tx rfb network rdr unixcommon)

# systemd support (socket activation)
if (LIBSYSTEMD_FOUND)
  target_link_libraries(x0vncserver ${LIBSYSTEMD_LIBRARIES})
endif()

if(X11_XTest_LIB)
  target_link_libraries(x0vncserver ${X11_XTest_LIB})
else()
  message(WARNING "No XTest extension.  x0vncserver will be view-only.")
endif()

if(X11_Xdamage_LIB)
  target_link_libraries(x0vncserver ${X11_Xdamage_LIB})
else()
  message(WARNING "No DAMAGE extension.  x0vncserver will have to use the slower polling method.")
endif()

if(X11_Xfixes_LIB)
  target_link_libraries(x0vncserver ${X11_Xfixes_LIB})
else()
  message(WARNING "No XFIXES extension.  x0vncserver will not be able to show cursors.")
endif()

if(X11_Xrandr_LIB)
  target_link_libraries(x0vncserver ${X11_Xrandr_LIB})
else()
  message(WARNING "No Xrandr extension.  x0vncserver will not be able to resize session.")
endif()

target_link_libraries(x0vncserver ${X11_LIBRARIES})

install(TARGETS x0vncserver DESTINATION ${CMAKE_INSTALL_FULL_BINDIR})
install(FILES x0vncserver.man DESTINATION ${CMAKE_INSTALL_FULL_MANDIR}/man1 RENAME x0vncserver.1)

=== debian/changelog ===
tigervnc (1.15.0+dfsg-2) unstable; urgency=medium

  [ Stephan Springl ]
  * Fix inetd mode of Xtigervnc. (closes: #1104740)

 -- Joachim Falk <joachim.falk@gmx.de>  Tue, 06 May 2025 00:30:59 +0200

tigervnc (1.15.0+dfsg-1) unstable; urgency=medium

  [ Joachim Falk ]
  * Fresh upstream TigerVNC 1.15.0
    - The native viewer and Unix servers now support the back and forward
      mouse buttons
    - The Unix servers can now handle any number of keys that are missing from
      the server keyboard layout, rather than just a few
    - x0tigervncserver now supports clipboard redirection
    - The native viewer can remember the username and password when
      reconnecting
    - The native viewer can now show a standard arrow cursor, not just a dot
      cursor, if the server cursor is blank
    - tigervncpasswd can now check password complexity with pwquality
  * Cache the VNC PasswordFile. In case the home directory becomes inaccessible,
    e.g., due to an expired Kerberos ticket, the VNC server still needs the
    content of the VNC password file. Otherwise, it is no longer possible to
    log in using the security types VncAuth or X509Vnc. (closes: #1087925)
  * Added missing dependencies to enable hardware-accelerated OpenGL and Vulkan
    APIs. (closes: #1103038)

 -- Joachim Falk <joachim.falk@gmx.de>  Fri, 18 Apr 2025 11:01:55 +0200

=== debian/control ===
--- 
+++ 
@@ -32,6 +32,8 @@
  libavcodec-dev,
  libavutil-dev,
  libswscale-dev,
+# For hardware accelerated OpenGL and Vulkan APIs
+ libgbm-dev,
  xorg-server-source (>= 2:21.1.10),
  xserver-xorg-dev,
  appstream,
@@ -39,7 +41,7 @@
 # debhelper-compat (= 12),
  po-debconf,
  quilt,
- pkg-config,
+ pkgconf,
  bison,
  flex,
  xutils-dev (>= 1:7.6+4),

=== debian/rules ===
--- 
+++ 
@@ -15,9 +15,10 @@
 
 # Normal situation
 #VNC_PATCH = $(CURDIR)/unix/xserver120.patch
+VNC_PATCH = $(CURDIR)/unix/xserver21.patch
 # However in this case we do not have this file from upstream so we use a
 # debian specific copy instead.
-VNC_PATCH = $(CURDIR)/debian/xserver121.patch
+#VNC_PATCH = $(CURDIR)/debian/xserver121.patch
 
 VNC_LIBTOOL_PATCH = $(CURDIR)/contrib/packages/deb/ubuntu-jammy/debian/xorg-source-patches/debian_libtool.patch
 
@@ -87,8 +88,6 @@
 		--enable-xephyr \
 		--enable-xorg \
 		--enable-dri \
-		--enable-dri2 \
-		--enable-dri3 \
 		--enable-xmir \
 	    , $(xserver_confflags) \
 	)
@@ -102,9 +101,7 @@
 	--disable-xnest \
 	--disable-xephyr \
 	--disable-xorg \
-	--disable-dri \
-	--disable-dri2 \
-	--disable-dri3
+	--disable-dri
 
 # Don't use libunwind for armel, armhf, and arm64 as this library is buggy
 # (bug #923962) on those architectures.
